varying vec3 lightVec;
varying vec3 viewVec;
varying vec2 texCoord;
varying vec4 aColor;

 varying vec3 Normal;
 varying vec3 LightVector;
varying float fogFactor;
varying float vertLen;

uniform sampler2D colorMap;
uniform sampler2D normalMap;
uniform sampler2D Foam;
// uniform sampler2D heightMap;
// uniform float invRadius;

void main (void)
{
	vec3 lVec = normalize(lightVec);
	vec3 vVec = normalize(viewVec);

	// Calculate offset, scale & biais
	vec4 bump = texture2D(normalMap, texCoord*8) + texture2D(normalMap, texCoord*32);
	float height = bump.a ;
//        vec3 h1 = texture2D(colorMap, texCoord).rgb ;
//	float height = h1.r + h1.b + h1.g;

//	vec2 newTexCoord = texCoord + ((height * 0.4 - 0.2) * (-vVec.xy));
//	vec2 newTexCoord = texCoord + ((height) * (-vVec.xy));
	vec2 newTexCoord = texCoord + ((height * 0.04 - 0.02) * (Normal.xy));
//	vec2 newTexCoord = texCoord + ((height*4) * (Normal.xy));
//	vec2 newTexCoord = texCoord + ((height * gl_FogFragCoord) * (-vVec.xy));
//	vec2 newTexCoord = texCoord + ((height / gl_FogFragCoord) * (-vVec.xy));
//	vec2 newTexCoord = texCoord + (height * (-vVec.xy));


	vec4 ColorBase = texture2D(colorMap, newTexCoord);
	vec4 base = aColor.rgba;
        vec4 foam = texture2D(Foam, newTexCoord*2) * texture2D(Foam, newTexCoord*32);
//	vec4 bump = texture2D(Foam, texCoord*16).rgba * texture2D(Foam, texCoord).rgba ;
	bump = normalize(bump);

	float diffuse = max( dot(lVec, bump.rgb), 0.0 );

	float specular = pow(clamp(dot(reflect(vVec, vec3(bump)), lVec), 0.0, 1.0), 1.0 );
        if (specular < 0.7) {specular = 0.0;} else {specular = 1.0;}
//        if (vertLen < 200.01) {specular = 0.0;}

//    Add('  vec3 reflect_vec = reflect(CameraVector, -Normal); ');
//    Add('  float Temp = dot(reflect_vec, LightVector); ');
//    Add('  vec4 SpecContrib = gl_LightSource[0].specular * clamp(pow(Temp, SpecPower), 0.0, 0.95); ');
//      Add('  gl_FragColor = LightIntensity * (TextureContrib * (gl_LightSource[0].ambient + DiffuseContrib) + SpecContrib); ')
//      Add('  gl_FragColor = mix(gl_Fog.color*gl_LightSource[0].ambient, LightIntensity * (TextureContrib * (gl_LightSource[0].ambient + DiffuseContrib) + SpecContrib), fogFactor ); ')

//	float specular = pow(clamp(dot(reflect(-vVec, bump), lVec), 0.0, 1.0), gl_FrontMaterial.shininess );
//	float specular = clamp(dot(reflect(-vVec, bump), lVec), 0.0, 1.0);

	vec4 vAmbient = gl_LightSource[0].ambient * gl_FrontMaterial.ambient;
	vec4 vDiffuse = gl_LightSource[0].diffuse * gl_FrontMaterial.diffuse * diffuse;
	vec4 vSpecular = gl_LightSource[0].specular * 1.0 * specular * gl_FrontMaterial.specular;
//	vec4 vSpecular = gl_LightSource[0].specular * (1.0 - height) *specular;

//   vec4 DiffuseContrib = clamp(gl_LightSource[0].diffuse * dot(LightVector, Normal), 0.0, 1.0);
   vec4 DiffuseContrib = clamp(gl_LightSource[0].diffuse * dot(lVec, Normal), 0.0, 1.0);

//	vec4 vAmbient = gl_LightSource[0].ambient ;
//	vec4 vDiffuse = gl_LightSource[0].diffuse * diffuse;
//	vec4 vSpecular = gl_LightSource[0].specular *specular;

//	gl_FragColor = vAmbient*base + (vDiffuse*base + vSpecular);

//	gl_FragColor = (vAmbient*base*3.0 + (DiffuseContrib*0.8+vDiffuse)*base + vSpecular)*0.8;

  foam.rgb = vec3( clamp((1-aColor.a)+aColor.g*1.0-aColor.b*0.95, 0.0, 1.0)*foam.rgb*foam.a )*6;
//  foam.rgb = vec3(0, 0, 0);

  gl_FragColor = mix(gl_Fog.color*gl_LightSource[0].ambient,
    (vAmbient*(base*ColorBase+foam) + (DiffuseContrib*0.8+vDiffuse)*(base*ColorBase+foam) + vSpecular)*0.8, fogFactor );
  gl_FragColor.a = aColor.a;
//  gl_FragColor = bump;
}



// uniform float LightIntensity;
// uniform float SpecPower;
// uniform sampler2D MainTexture;

// varying vec3 Normal;
// varying vec3 LightVector;
// varying vec3 CameraVector;
// varying float fogFactor;

// void main(void)
// {
//   vec4 TextureContrib = texture2D(MainTexture, gl_TexCoord[0].xy);
//   float TextureContribA = TextureContrib.a;
//   vec4 DiffuseContrib = clamp(gl_LightSource[0].diffuse * dot(LightVector, Normal), 0.0, 1.0);

//   vec3 reflect_vec = reflect(CameraVector, -Normal);
//   float Temp = dot(reflect_vec, LightVector);
//   vec4 SpecContrib = gl_LightSource[0].specular * clamp(pow(Temp, SpecPower), 0.0, 0.95);

//   gl_FragColor = mix(gl_Fog.color*gl_LightSource[0].ambient,
//     LightIntensity * (TextureContrib * (gl_LightSource[0].ambient + DiffuseContrib) + SpecContrib), fogFactor );

//  gl_FragColor = mix(gl_Fog.color*gl_LightSource[0].ambient,
//    TextureContrib * LightIntensity * (gl_LightSource[0].ambient + DiffuseContrib + SpecContrib), fogFactor );

//   gl_FragColor.a = TextureContribA;
// }
